# Build

Make sure cmake is installed.

Run cmake to generate the build file, and build it
 
    mkdir build
    cd build 
    cmake ..
    make

# The unit test

Make sure you run the unit test by running 
./embeddedlab 

And you will most likely see some output like the following 

OK - AES128 CBC encrypt
OK - AES128 CBC decrypt
OK - AES128 ECB encrypt
OK - AES128 ECB decrypt
OK - AES ECB buffer encrypt and decrypt
OK - user test
OK - AES key gen verification
OK - encrypt and decrypt file

Data fetched success!
OK - Train Model
OK - Save Model
OK - Load Model
Data fetched success!
1
2
1
1
OK - Make Prediction

# Command Line Tool

+ Account
    + initialize new user database
        + ./embeddedlab account init [path to user database]
        
    + authenticate user
        + ./embeddedlab account authenticate [username][password][path to user database]
        
    + add a new user
        + ./embeddedlab account add [username to add][password of the new user][username][password][path to user database]
        
    + remove a existing user
        + ./embeddedlab account remove [username to remove][username][password][path to user database]
        
        
+ ML
    + train
        + ./embeddedlab ml train [path to data][path to save model][username][password][path to user database]
        
    + inference
        + ./embeddedlab ml inference [path to test data][path to saved model][username][password][path to user database]
        
        
# Example

## Kmeans

    

## CNN

    $ ./embeddedlab account init userDB
    account operation
    user database initialized.
    a default user 'admin' with password 'admin' is created.
    
    $ ./embeddedlab account add bob password admin admin userDB 
    account operation
    user 'bob' is added to the database.
    
    $ ./embeddedlab account add alice password bob password userDB
    account operation
    user 'alice' is added to the database.
    
    $ ./embeddedlab account add alice password bob passwordy userDB
    account operation
    user is not authorized, please log in first.
    
    $ ./embeddedlab account remove bob alice password userDB
    account operation
    user 'bob' is removed from the database.
    
    $ ./embeddedlab ml train ../data/geo/encryptedData nn_model alice password userDB
    ml operation
    case 1000 err=76.7431
    case 2000 err=64.3735
    case 3000 err=55.8054
    case 4000 err=50.3823
    ......
    case 119000 err=15.3221
    case 120000 err=15.2539

    $ ./embeddedlab ml inference ../data/geo/encryptedTrainingSamples nn_model alice password userDB
    ml operation
    inference result: 
    [0] 0.087661
    [1] 0.018613
    [2] 10.248626
    [3] 4.046494
    [4] 0.005082
    [5] 1.384205
    [6] 0.009051
    [7] 0.008383
    [8] 71.340645
    [9] 2.455639


