
#pragma once

#include <cstring>
#include <cstdio>
#include <string>
#include <iterator>
#include "ml/kmeans/kmeans.h"
#include "ml/svm/svm.h"
#include "ml/cnn/cnn.h"
#include "SysParam.h"

class MlModule {

private:

    const char* temp = "/tmp/scratchMlModel";
    
    MlModule() = default;

    MlModule(MlModule const &) = default;

    MlModule &operator=(MlModule const &);

    static MlModule *mlInstance;

    KMeans model_kmeans = KMeans();

public:
    static MlModule *getInstance();

    int saveMlModel(const char *modelPath);

    int loadSavedMlModel(const char *modelPath);

    int trainMlModel(const char *trainingSamplePath);

    int makeInference(const char *samplePath);
};