//
// Created by fangchenli on 8/23/19.
//

#ifndef EMBEDDEDLAB_MLSOLUTIONS_H
#define EMBEDDEDLAB_MLSOLUTIONS_H

//--------------------------------------------------------
// nn model
//    vector<layer_t *> model;
//-------------------------------------------------------------------------
// variables for svm
//    struct svm_parameter param;        // set by parse_command_line
//    struct svm_problem prob;        // set by read_problem
//    struct svm_model *model;
//    struct svm_node *x_space;
//    int cross_validation;
//    int nr_fold;
//    int predict_probability = 0;
//-------------------------------------------------------------------------


//// --------------------------------answer for cnn--------------------------------------------
//
//uint32_t byteswap_uint32(uint32_t a) {
//    return ((((a >> 24) & 0xff) << 0) |
//            (((a >> 16) & 0xff) << 8) |
//            (((a >> 8) & 0xff) << 16) |
//            (((a >> 0) & 0xff) << 24));
//}
//
//struct case_t {
//    tensor_t<float> data;
//    tensor_t<float> out;
//};
//
//uint8_t *read_file(const char *szFile) {
//    std::ifstream file(szFile, std::ios::binary | std::ios::ate);
//    std::streamsize size = file.tellg();
//    file.seekg(0, std::ios::beg);
//
//    if (size == -1)
//        return nullptr;
//
//    auto *buffer = new uint8_t[size];
//    file.read((char *) buffer, size);
//    return buffer;
//}
//
//std::vector<case_t> read_test_cases() {
//    std::vector<case_t> cases;
//
//    uint8_t *train_image = read_file("data/mnist/train-images.idx3-ubyte");
//    uint8_t *train_labels = read_file("data/mnist/train-labels.idx1-ubyte");
//
//    uint32_t case_count = byteswap_uint32(*(uint32_t *) (train_image + 4));
//
//    for (size_t i = 0; i < case_count; i++) {
//        case_t c
//                {
//                        tensor_t<float>(28, 28, 1),
//                        tensor_t<float>(10, 1, 1)
//                };
//
//        uint8_t *img = train_image + 16 + i * (28 * 28);
//        uint8_t *label = train_labels + 8 + i;
//
//        for (int x = 0; x < 28; x++)
//            for (int y = 0; y < 28; y++)
//                c.data(x, y, 0) = (float) img[x + y * 28] / 255.f;
//
//        for (int b = 0; b < 10; b++)
//            c.out(b, 0, 0) = *label == b ? 1.0f : 0.0f;
//
//        cases.push_back(c);
//    }
//    delete[] train_image;
//    delete[] train_labels;
//
//    return cases;
//}
//
//void forward(std::vector<layer_t *> &layers, tensor_t<float> &data) {
//    for (size_t i = 0; i < layers.size(); i++) {
//        if (i == 0)
//            activate(layers[i], data);
//        else
//            activate(layers[i], layers[i - 1]->out);
//    }
//}
//
//float train(std::vector<layer_t *> &layers, tensor_t<float> &data, tensor_t<float> &expected) {
//    for (size_t i = 0; i < layers.size(); i++) {
//        if (i == 0)
//            activate(layers[i], data);
//        else
//            activate(layers[i], layers[i - 1]->out);
//    }
//
//    tensor_t<float> grads = layers.back()->out - expected;
//
//    for (int i = layers.size() - 1; i >= 0; i--) {
//        if (i == layers.size() - 1)
//            calc_grads(layers[i], grads);
//        else
//            calc_grads(layers[i], layers[i + 1]->grads_in);
//    }
//
//    for (auto &layer : layers) {
//        fix_weights(layer);
//    }
//
//    float err = 0;
//    for (int i = 0; i < grads.size.x * grads.size.y * grads.size.z; i++) {
//        float f = expected.data[i];
//        if (f > 0.5)
//            err += std::abs(grads.data[i]);
//    }
//    return err * 100;
//}
//
///**
// * save the nn model to file
// * @param layers: a vector of layer_t
// * @param path a file path to save the model
// * @return 0 to indicate success
// */
//int save_network(const std::vector<layer_t *> &layers, const char *path) {
//    std::ofstream out(path);
//    for (auto &layer : layers) {
//        // each type of layer has its own toString method
//        out << toString(layer);
//    }
//    out.close();
//    return 0;
//}
//
///**
// * load the model from a file
// * @param path a file path that contains the nn model
// * @return a vector of layers
// */
//std::vector<layer_t *> load_network(const char *path) {
//    std::vector<layer_t *> layers_loaded;
//    std::ifstream infile;
//    infile.open(path, std::ios::in);
//    if (infile.is_open()) {
//
//        std::string line;
//        while (getline(infile, line)) {
//
//            if (line.length() != 0) {
//
//                // fully connected layer
//                if (line == "fc") {
//                    getline(infile, line);
//                    tensor_t<float> tensor_in = string_to_tensor(line);
//
//                    getline(infile, line);
//                    tensor_t<float> tensor_out = string_to_tensor(line);
//
//                    getline(infile, line);
//                    tensor_t<float> tensor_weight = string_to_tensor_trans(line);
//
//                    getline(infile, line);
//                    tensor_t<float> tensor_grads_in = string_to_tensor(line);
//
//                    layers_loaded.emplace_back(
//                            (layer_t *) new fc_layer_t(tensor_in, tensor_out, tensor_weight, tensor_grads_in));
//                }
//
//                // convolution layer
//                if (line == "conv") {
//                    getline(infile, line);
//                    tensor_t<float> tensor_in = string_to_tensor(line);
//
//                    getline(infile, line);
//                    tensor_t<float> tensor_out = string_to_tensor(line);
//
//                    getline(infile, line);
//                    tensor_t<float> tensor_grads_in = string_to_tensor(line);
//
//                    std::vector<tensor_t<float>> filters;
//                    while (true) {
//                        getline(infile, line);
//                        if (line == "end") {
//                            break;
//                        }
//                        filters.push_back(string_to_tensor(line));
//                    }
//
//                    getline(infile, line);
//                    int extend_filter = stoi(line);
//
//                    getline(infile, line);
//                    int stride = stoi(line);
//
//                    layers_loaded.emplace_back(
//                            (layer_t *) new conv_layer_t(tensor_in, tensor_out, tensor_grads_in, filters, extend_filter,
//                                                         stride));
//                }
//
//                // relu layer
//                if (line == "relu") {
//                    getline(infile, line);
//                    tensor_t<float> tensor_in = string_to_tensor(line);
//
//                    getline(infile, line);
//                    tensor_t<float> tensor_out = string_to_tensor(line);
//
//                    getline(infile, line);
//                    tensor_t<float> tensor_grads_in = string_to_tensor(line);
//
//                    layers_loaded.emplace_back((layer_t *) new relu_layer_t(tensor_in, tensor_out, tensor_grads_in));
//                }
//
//                // pool layer
//                if (line == "pool") {
//                    getline(infile, line);
//                    tensor_t<float> tensor_in = string_to_tensor(line);
//
//                    getline(infile, line);
//                    tensor_t<float> tensor_out = string_to_tensor(line);
//
//                    getline(infile, line);
//                    tensor_t<float> tensor_grads_in = string_to_tensor(line);
//
//                    getline(infile, line);
//                    int extend_filter = stoi(line);
//
//                    getline(infile, line);
//                    int stride = stoi(line);
//
//                    layers_loaded.emplace_back(
//                            (layer_t *) new pool_layer_t(tensor_in, tensor_out, tensor_grads_in, extend_filter,
//                                                         stride));
//                }
//            }
//        }
//        infile.close();
//    }
//    return layers_loaded;
//}
//
///**
// * test the model with a single image
// * @param layers: a vector of layers, the nn model
// * @param path: a path to the image file
// */
//void test(std::vector<layer_t *> &layers, const char *path) {
//    uint8_t *data = read_file(path);
//    if (data) {
//        uint8_t *usable = data;
//
//        while (*(uint32_t *) usable != 0x0A353532)
//            usable++;
//
//#pragma pack(push, 1)
//        struct RGB {
//            uint8_t r, g, b;
//        };
//#pragma pack(pop)
//
//        RGB *rgb = (RGB *) usable;
//
//        tensor_t<float> image(28, 28, 1);
//        for (int i = 0; i < 28; i++) {
//            for (int j = 0; j < 28; j++) {
//                RGB rgb_ij = rgb[i * 28 + j];
//                image(j, i, 0) = ((((float) rgb_ij.r
//                                    + (float) rgb_ij.g
//                                    + (float) rgb_ij.b)
//                                   / (3.0f * 255.f)));
//            }
//        }
//
//        std::cout << "inference result: " << std::endl;
//        forward(layers, image);
//        tensor_t<float> &out = layers.back()->out;
//        for (int i = 0; i < 10; i++) {
//            printf("[%i] %f\n", i, out(i, 0, 0) * 100.0f);
//        }
//    }
//}
//
//int MlModule::trainMlModel(const char *trainingSamplePath) {
//
//    // load training data
//    vector<case_t> cases = read_test_cases();
//
//    // build model
//    model.emplace_back((layer_t *) new conv_layer_t(1, 5, 8, cases[0].data.size)); // 28 * 28 * 1 -> 24 * 24 * 8
//    model.emplace_back((layer_t *) new relu_layer_t(model.back()->out.size));
//    model.emplace_back((layer_t *) new pool_layer_t(2, 2, model.back()->out.size)); // 24 * 24 * 8 -> 12 * 12 * 8
//    model.emplace_back((layer_t *) new fc_layer_t(model.back()->out.size, 10)); // 4 * 4 * 16 -> 10
//
//    float amse = 0;
//    int ic = 0;
//
//    for (long ep = 0; ep < 100000;) {
//
//        for (case_t &t : cases) {
//            float xerr = train(model, t.data, t.out);
//            amse += xerr;
//
//            ep++;
//            ic++;
//
//            if (ep % 1000 == 0)
//                cout << "case " << ep << " err=" << amse / (float) ic << endl;
//
//            // if ( GetAsyncKeyState( VK_F1 ) & 0x8000 )
//            // {
//            //	   printf( "err=%.4f%\n", amse / ic  );
//            //	   goto end;
//            // }
//        }
//    }
//    return SUCCESS;
//}
//
//int MlModule::saveMlModel(const char *modelPath) {
//    save_network(model, modelPath);
//    return SUCCESS;
//}
//
//int MlModule::loadSavedMlModel(const char *modelPath) {
//    model = load_network(modelPath);
//    return SUCCESS;
//}
//
//int MlModule::inference(const char *samplePath) {
//    test(model, samplePath);
//    return SUCCESS;
//}


//// --------------------------------answer for svm--------------------------------------------
//
//#define Malloc(type, n) (type *)malloc((n)*sizeof(type))
//
//static int max_line_len;
//static char *line = nullptr;
//
//struct svm_node *x;
//int max_nr_attr = 64;
//
//static char *readline(FILE *input) {
//    int len;
//
//    if (fgets(line, max_line_len, input) == nullptr)
//        return nullptr;
//
//    while (strrchr(line, '\n') == nullptr) {
//        max_line_len *= 2;
//        line = (char *) realloc(line, max_line_len);
//        len = (int) strlen(line);
//        if (fgets(line + len, max_line_len - len, input) == nullptr)
//            break;
//    }
//    return line;
//}
//
//void exit_input_error(int line_num) {
//    fprintf(stderr, "Wrong input format at line %d\n", line_num);
//    exit(1);
//}
//
//static int (*info)(const char *fmt, ...) = &printf;
//
//int MlModule::trainMlModel(const char *trainingSamplePath) {
//    // default values
//    param.svm_type = C_SVC;
//    param.kernel_type = RBF;
//    param.degree = 3;
//    param.gamma = 0;    // 1/num_features
//    param.coef0 = 0;
//    param.nu = 0.5;
//    param.cache_size = 100;
//    param.C = 1;
//    param.eps = 1e-3;
//    param.p = 0.1;
//    param.shrinking = 1;
//    param.probability = 0;
//    param.nr_weight = 0;
//    param.weight_label = nullptr;
//    param.weight = nullptr;
//    cross_validation = 0;
//
//    int max_index, inst_max_index, i;
//    size_t elements, j;
//    FILE *fp = fopen(trainingSamplePath, "r");
//    char *endptr;
//    char *idx, *val, *label;
//
//    if (fp == nullptr) {
//        fprintf(stderr, "can't open input file %s\n", trainingSamplePath);
//        exit(1);
//    }
//
//    prob.l = 0;
//    elements = 0;
//
//    max_line_len = 1024;
//    line = Malloc(char, max_line_len);
//    while (readline(fp) != nullptr) {
//        char *p = strtok(line, " \t"); // label
//
//        // features
//        while (true) {
//            p = strtok(nullptr, " \t");
//            if (p == nullptr || *p == '\n') // check '\n' as ' ' may be after the last feature
//                break;
//            ++elements;
//        }
//        ++elements;
//        ++prob.l;
//    }
//    rewind(fp);
//
//    prob.y = Malloc(double, prob.l);
//    prob.x = Malloc(struct svm_node *, prob.l);
//    x_space = Malloc(struct svm_node, elements);
//
//    max_index = 0;
//    j = 0;
//    for (i = 0; i < prob.l; i++) {
//        inst_max_index = -1; // strtol gives 0 if wrong format, and precomputed kernel has <index> start from 0
//        readline(fp);
//        prob.x[i] = &x_space[j];
//        label = strtok(line, " \t\n");
//        if (label == nullptr) // empty line
//            exit_input_error(i + 1);
//
//        prob.y[i] = strtod(label, &endptr);
//        if (endptr == label || *endptr != '\0')
//            exit_input_error(i + 1);
//
//        while (true) {
//            idx = strtok(nullptr, ":");
//            val = strtok(nullptr, " \t");
//
//            if (val == nullptr)
//                break;
//
//            errno = 0;
//            x_space[j].index = (int) strtol(idx, &endptr, 10);
//            if (endptr == idx || errno != 0 || *endptr != '\0' || x_space[j].index <= inst_max_index)
//                exit_input_error(i + 1);
//            else
//                inst_max_index = x_space[j].index;
//
//            errno = 0;
//            x_space[j].value = strtod(val, &endptr);
//            if (endptr == val || errno != 0 || (*endptr != '\0' && !isspace(*endptr)))
//                exit_input_error(i + 1);
//
//            ++j;
//        }
//
//        if (inst_max_index > max_index)
//            max_index = inst_max_index;
//        x_space[j++].index = -1;
//    }
//
//    if (param.gamma == 0 && max_index > 0)
//        param.gamma = 1.0 / max_index;
//
//    if (param.kernel_type == PRECOMPUTED)
//        for (i = 0; i < prob.l; i++) {
//            if (prob.x[i][0].index != 0) {
//                fprintf(stderr, "Wrong input format: first column must be 0:sample_serial_number\n");
//                exit(1);
//            }
//            if ((int) prob.x[i][0].value <= 0 || (int) prob.x[i][0].value > max_index) {
//                fprintf(stderr, "Wrong input format: sample_serial_number out of range\n");
//                exit(1);
//            }
//        }
//
//    fclose(fp);
//
//    model = svm_train(&prob, &param);
//
//    return SUCCESS;
//}
//
//int MlModule::saveMlModel(const char *modelPath) {
//    int saveResult = svm_save_model(modelPath, this->model);
//    svm_free_and_destroy_model(&this->model);
//    svm_destroy_param(&this->param);
//    return saveResult;
//}
//
//int MlModule::loadSavedMlModel(const char *modelPath) {
//    this->model = svm_load_model(modelPath);
//
//    return SUCCESS;
//}
//
//int MlModule::inference(const char *samplePath) {
//
//    predict_probability = 0;
//
//    const char *outputPath = "output";
//
//    FILE *input = fopen(samplePath, "r");
//    FILE *output = fopen(outputPath, "w");
//
//    x = (struct svm_node *) malloc(max_nr_attr * sizeof(struct svm_node));
//
//    int correct = 0;
//    int total = 0;
//    double error = 0;
//    double sump = 0, sumt = 0, sumpp = 0, sumtt = 0, sumpt = 0;
//
//    int svm_type = svm_get_svm_type(this->model);
//    int nr_class = svm_get_nr_class(this->model);
//    double *prob_estimates = nullptr;
//    int j;
//
//    if (predict_probability) {
//        if (svm_type == NU_SVR || svm_type == EPSILON_SVR)
//            info("Prob. model for test data: target value = predicted value + z,\nz: Laplace distribution e^(-|z|/sigma)/(2sigma),sigma=%g\n",
//                 svm_get_svr_probability(this->model));
//        else {
//            int *labels = (int *) malloc(nr_class * sizeof(int));
//            svm_get_labels(this->model, labels);
//            prob_estimates = (double *) malloc(nr_class * sizeof(double));
//            fprintf(output, "labels");
//            for (j = 0; j < nr_class; j++)
//                fprintf(output, " %d", labels[j]);
//            fprintf(output, "\n");
//            free(labels);
//        }
//    }
//
//    max_line_len = 1024;
//    line = (char *) malloc(max_line_len * sizeof(char));
//    while (readline(input) != nullptr) {
//        int i = 0;
//        double target_label, predict_label;
//        char *idx, *val, *label, *endptr;
//        int inst_max_index = -1; // strtol gives 0 if wrong format, and precomputed kernel has <index> start from 0
//
//        label = strtok(line, " \t\n");
//        if (label == nullptr) // empty line
//            exit_input_error(total + 1);
//
//        target_label = strtod(label, &endptr);
//        if (endptr == label || *endptr != '\0')
//            exit_input_error(total + 1);
//
//        while (true) {
//            if (i >= max_nr_attr - 1)    // need one more for index = -1
//            {
//                max_nr_attr *= 2;
//                x = (struct svm_node *) realloc(x, max_nr_attr * sizeof(struct svm_node));
//            }
//
//            idx = strtok(nullptr, ":");
//            val = strtok(nullptr, " \t");
//
//            if (val == nullptr)
//                break;
//            errno = 0;
//            x[i].index = (int) strtol(idx, &endptr, 10);
//            if (endptr == idx || errno != 0 || *endptr != '\0' || x[i].index <= inst_max_index)
//                exit_input_error(total + 1);
//            else
//                inst_max_index = x[i].index;
//
//            errno = 0;
//            x[i].value = strtod(val, &endptr);
//            if (endptr == val || errno != 0 || (*endptr != '\0' && !isspace(*endptr)))
//                exit_input_error(total + 1);
//
//            ++i;
//        }
//        x[i].index = -1;
//
//        if (predict_probability && (svm_type == C_SVC || svm_type == NU_SVC)) {
//            predict_label = svm_predict_probability(this->model, x, prob_estimates);
//            fprintf(output, "%g", predict_label);
//            for (j = 0; j < nr_class; j++)
//                fprintf(output, " %g", prob_estimates[j]);
//            fprintf(output, "\n");
//        } else {
//            predict_label = svm_predict(this->model, x);
//            fprintf(output, "%.17g\n", predict_label);
//        }
//
//        if (predict_label == target_label)
//            ++correct;
//        error += (predict_label - target_label) * (predict_label - target_label);
//        sump += predict_label;
//        sumt += target_label;
//        sumpp += predict_label * predict_label;
//        sumtt += target_label * target_label;
//        sumpt += predict_label * target_label;
//        ++total;
//    }
//    if (svm_type == NU_SVR || svm_type == EPSILON_SVR) {
//        info("Mean squared error = %g (regression)\n", error / total);
//        info("Squared correlation coefficient = %g (regression)\n",
//             ((total * sumpt - sump * sumt) * (total * sumpt - sump * sumt)) /
//             ((total * sumpp - sump * sump) * (total * sumtt - sumt * sumt))
//        );
//    } else
//        info("Accuracy = %g%% (%d/%d) (classification)\n",
//             (double) correct / total * 100, correct, total);
//    if (predict_probability)
//        free(prob_estimates);
//
//    svm_free_and_destroy_model(&this->model);
//    svm_destroy_param(&this->param);
//    return 0;
//}

#endif //EMBEDDEDLAB_MLSOLUTIONS_H
